Subject: Re: [PATCH] ar5523: Fix null-ptr-deref with unexpected WDCMSG_TARGET_START reply

From: Kalle Valo <[email-masked]>
Date: Wed, 10 Nov 2021 16:56:52 +0200

Zekun Shen <[email-masked]> writes:

> On Fri, Oct 29, 2021 at 06:53:30AM +0300, Kalle Valo wrote:
>> Zekun Shen <[email-masked]> writes:
>> 
>> > Unexpected WDCMSG_TARGET_START replay can lead to null-ptr-deref
>> > when ar->tx_cmd->odata is NULL. The patch adds a null check to
>> > prevent such case.
>> >
>> > KASAN: null-ptr-deref in range [0x0000000000000000-0x0000000000000007]
>> >  ar5523_cmd+0x46a/0x581 [ar5523]
>> >  ar5523_probe.cold+0x1b7/0x18da [ar5523]
>> >  ? ar5523_cmd_rx_cb+0x7a0/0x7a0 [ar5523]
>> >  ? __pm_runtime_set_status+0x54a/0x8f0
>> >  ? _raw_spin_trylock_bh+0x120/0x120
>> >  ? pm_runtime_barrier+0x220/0x220
>> >  ? __pm_runtime_resume+0xb1/0xf0
>> >  usb_probe_interface+0x25b/0x710
>> >  really_probe+0x209/0x5d0
>> >  driver_probe_device+0xc6/0x1b0
>> >  device_driver_attach+0xe2/0x120
>> >
>> > Signed-off-by: Zekun Shen <[email-masked]>
>> 
>> How did you test this?
>
> I found the bug using a custome USBFuzz port. It's a research work
> to fuzz USB stack/drivers. I modified it to fuzz ath9k driver only,
> providing hand-crafted usb descriptors to QEMU.
>
> After fixing the code (fourth byte in usb packet) to WDCMSG_TARGET_START, 
> I got the null-ptr-deref bug. I believe the bug is triggerable whenever
> cmd->odata is NULL. After patching, I tested with the same input and no
> longer see the KASAN report.

Ok, so you didn't test this on a real device at all. I'll mention that
in the commit log and also copy what you wrote above.

-- 
https://patchwork.kernel.org/project/linux-wireless/list/

https://wireless.wiki.kernel.org/en/developers/documentation/submittingpatches